#include <u.h>
#include <libc.h>

void usage(void)
{
	print("Line numerator\nUsage: ln filename\n");
	exits(0);
}

void main(int argc,char** argv)
{
	Dir *d;
	int fd,lnum=0,plen;
	char *s,*s1,*s2,*send;
	char num[10];

	if (argc!=2)
		usage();

	if ((fd=open(argv[1],OREAD))<0)
		print("can't open %s",argv[1]);
	else
	{
		d=dirfstat(fd);
		if ((s=malloc(d->length+1))!=0)
		{
			read(fd,s,d->length);
			s[d->length]=0;

			s1=s; send=s1+d->length;
			for(s2=strchr(s1,'\n'); s2!=0; s2=strchr(s1,'\n'))
			{
				lnum++;
				s1=s2+1;
			}
			sprint(num,"%d",lnum);
			plen=strlen(num);

			lnum=0;	s1=s; send=s1+d->length;
			for(s2=strchr(s1,'\n'); s2!=0; s2=strchr(s1,'\n'))
			{
				lnum++;
				print("%0*d\t%.*s\n",plen,lnum,s2-s1,s1);
				s1=s2+1;
			}

			free(s);
		}
	}

	exits(0);
}